/**
 * Ladder, empowering Model Driven Architecture in J2EE applications
 *
 * Copyright (c) 2012, Dilip Dalton or third-party contributors as
 * indicated by the @author tags.
 *
 * This copyrighted material is made available to anyone wishing to use, modify,
 * copy, or redistribute it subject to the terms and conditions of the GNU
 * Lesser General Public License, as published by the Free Software Foundation.
 *
 * Ladder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this distribution. If not, see <http://www.gnu.org/licenses/>.
 */

package ws.ladder.model.action;

import ws.ladder.model.CallInfo;
import ws.ladder.model.ExtendedDataObject;

public abstract class AbstractElementAction implements ElementAction {

	protected final PropertyKey key;
	protected final ExtendedDataObject collectionElement;	
	protected final ExtendedDataObject collectionOwner;
	protected final Executable triggeringAction;
	protected final Object position;
	protected final CallInfo callInfo;

	public AbstractElementAction(PropertyKey key, ExtendedDataObject collectionElement, ExtendedDataObject collectionOwner, Executable triggeringAction, Object position, CallInfo callInfo) {
		this.key = key;
		this.collectionElement = collectionElement;
		this.collectionOwner = collectionOwner;
		this.triggeringAction = triggeringAction;
		this.position = position;
		this.callInfo = callInfo;
	}

	@Override
	public void execute() {

	}	

	@Override
	public PropertyKey getKey() {
		return key;
	}

	@Override
	public ExtendedDataObject getCollectionElement() {
		return collectionElement;
	}
	
	@Override
	public ExtendedDataObject getCollectionOwner() {
		return this.collectionOwner;
	}

	@Override
	public Executable getTriggeringAction() {
		return this.triggeringAction;
	}

	@Override
	public Object getPosition() {
		return this.position;
	}

	@Override
	public CallInfo getCallInfo() {
		return this.callInfo;
	}			
}
