/**
 * Ladder, empowering Model Driven Architecture in J2EE applications
 *
 * Copyright (c) 2012, Dilip Dalton or third-party contributors as
 * indicated by the @author tags.
 *
 * This copyrighted material is made available to anyone wishing to use, modify,
 * copy, or redistribute it subject to the terms and conditions of the GNU
 * Lesser General Public License, as published by the Free Software Foundation.
 *
 * Ladder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this distribution. If not, see <http://www.gnu.org/licenses/>.
 */

package ws.ladder.service;

import javax.enterprise.inject.Alternative;
import javax.enterprise.inject.spi.BeanManager;
import javax.enterprise.inject.spi.InjectionTarget;
import javax.inject.Inject;

import ws.ladder.util.ClassUtil;

@Alternative
public class CDIDASFactory extends AbstractDASFactory {
	
	@Inject private BeanManager beanManager;

	@Override
	public void injectDependencies(Object bean, String name) {
	    InjectionTarget injectionTarget = beanManager.createInjectionTarget(beanManager.createAnnotatedType(ClassUtil.getUnEnhanced(bean.getClass())));		
	    injectionTarget.inject(bean, beanManager.createCreationalContext(null));
	    injectionTarget.postConstruct(bean);
	}
}