import java.io.IOException;
import java.io.RandomAccessFile;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;

/**
 * Global Meta data
 * ================
 * First free block
 * 
 * Extent meta data
 * ================
 * Data Size       (Size of the data content excluding the header data size)
 * Extent size     (Size of this extent, including the extent meta data)
 * next extent     (If the data size is greater than the extent size)
 * Next free block (populated if this is a free block)
 * 
 * @author Dilip Dalton
 *
 */
public class FileSystemManager {
	
	// TODO: return a FileSystemSession object for the current thread that will 
	// do the following operations
	
	// List of commands. The commands can be undone to support rollback
	// The manager has a list of data files
	
	private long getFreeBlockPosition() {
		// read the global meta data in the file
		return 0;
	}
	
	public void saveOrUpdate(String id, byte[] data) {
		
	}
	
	public void delete(String id) {
		
	}
	
	public byte[] findById(String id) {
		return null;
	}
	
	public void flush() {
		// execute all the queued up commands in the order received
		
		// if rolling back, undo them in the reverse order
	}

	public static void main(String[] args) {
		String s = "I was here!\n";
		byte data[] = s.getBytes();
		ByteBuffer out = ByteBuffer.wrap(data);

		ByteBuffer copy = ByteBuffer.allocate(12);

		try {
			//Path path = FileSystems.getDefault().getPath("data", "data.txt");
			//FileChannel fc = (FileChannel.open(path, StandardOpenOption.READ, StandardOpenOption.WRITE));
			RandomAccessFile raf = new RandomAccessFile("data/data.txt", "rw");
			FileChannel fc = raf.getChannel();
			
			// Read the first 12
			// bytes of the file.
			int nread;
			do {
				nread = fc.read(copy);
			} while (nread != -1 && copy.hasRemaining());

			// Write "I was here!" at the beginning of the file.
			fc.position(0);
			while (out.hasRemaining())
				fc.write(out);
			out.rewind();

			// Move to the end of the file.  Copy the first 12 bytes to
			// the end of the file.  Then write "I was here!" again.
			long length = fc.size();
			fc.position(length-1 + 300);
			copy.flip();
			while (copy.hasRemaining())
				fc.write(copy);
			while (out.hasRemaining())
				fc.write(out);
		} catch (IOException x) {
			System.out.println("I/O Exception: " + x);
		}
	}
}